#ifndef APERTURE
#define APERTURE

#include <strstream.h>

enum SHAPES { NOSHAPE, CIRCULAR, RECTANGULAR, OCTAGONAL, ROUNDRECT, CROSSHAIR, MOIRE };
enum TYPES  { NOTYPE, LINE, FLASH, MULTI }; 

#define DCODE_BASE 11

class CAperture
{
private:
	int 		m_nXSize;
	int 		m_nYSize;
	SHAPES 		m_shape;
	TYPES		m_type;
	int 		m_nID;
	CAperture* 	m_pNext;
	CAperture*  m_pThis;
	CAperture* 	m_pLast;
public:
	static int 	totalAperture;
	static int 	m_nPGEnlg;
	static int 	m_nSMEnlg;
	static int 	m_nPMEnlg;
	static 		CAperture* p_finalAperture;
	static		CAperture* p_firstAperture;
public:
				CAperture(SHAPES shp = CIRCULAR, TYPES type = MULTI, int nX = 0, int nY = 0);
				~CAperture();
	static int 	CreateAperture(CString type, char far* data);
	static void DestroyAperture();
	static BOOL ApertureExists(SHAPES shp, TYPES type, int nX, int nY);
	static BOOL WriteApertures(CStdioFile* p_outFile);
// 	helpers
	CAperture*	GetNext() 	const 	{ return m_pNext; } 
	CAperture*	GetThis() 	const 	{ return m_pThis; }
	CAperture*	GetLast() 	const 	{ return m_pLast; }
	int			GetX()    	const 	{ return m_nXSize; }
	int			GetY()    	const 	{ return m_nYSize; }
	int			GetID()    	const 	{ return m_nID; }
	SHAPES		GetShape() 	const 	{ return m_shape; } 
	TYPES		GetType()   const 	{ return m_type; }
	void		SetX(int x)    	 	{ m_nXSize = x; }
	void		SetY(int y)    	 	{ m_nYSize = y; }
	void		SetID(int nID)    	{ m_nID = nID; }
	void		SetShape(SHAPES shp){ m_shape = shp; }
	void		SetType(TYPES type) { m_type = type; }
	
//  friend functions
	friend BOOL     operator == (const CAperture& ca1, const CAperture& ca2);
};

#endif
