// dcodevw.cpp : implementation of the CDcodeView class
//

#include "stdafx.h" 
#include "dcodedoc.h"

#include "dcodevw.h" 
#include "dcode.h"


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

extern char* far shapenames[];
extern char* far typenames[];

/////////////////////////////////////////////////////////////////////////////
// CDcodeView

IMPLEMENT_DYNCREATE(CDcodeView, CFormView)

BEGIN_MESSAGE_MAP(CDcodeView, CFormView)
	//{{AFX_MSG_MAP(CDcodeView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDcodeView construction/destruction

CDcodeView::CDcodeView()
	: CFormView(CDcodeView::IDD)
{
	//{{AFX_DATA_INIT(CDcodeView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here 
}

CDcodeView::~CDcodeView()
{
}

void CDcodeView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDcodeView)
	DDX_Control(pDX, IDC_APER_LIST, m_cAperList);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CDcodeView diagnostics

#ifdef _DEBUG
void CDcodeView::AssertValid() const
{
	CFormView::AssertValid();
}

void CDcodeView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CDcodeDoc* CDcodeView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDcodeDoc)));
	return (CDcodeDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDcodeView message handlers 

void CDcodeView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint )
{
	CDcodeDoc* pDoc = (CDcodeDoc*) GetDocument();
	CString str("");
	POSITION pos; 
	TRACE("\n");
	m_cAperList.ResetContent();
					 
	for(pos = (pDoc->m_pApList)->GetHeadPosition(); pos != NULL; )
	{
		CApertureObject* pObj = (CApertureObject*) (pDoc->m_pApList)->GetNext(pos);
		char buffer[50];
		
		sprintf(buffer, "%-11s%4d%4d%3d%6s", 
				shapenames[pObj->GetShape()], pObj->GetX(), pObj->GetY(), 
				0, typenames[pObj->GetType()]);
		TRACE("\n%s", buffer);
		str = CString(buffer); 
		m_cAperList.AddString(str);		
	}
	if(pos != NULL)
	{
		SetDlgItemInt(IDC_TOTAL_APER_COUNT, CApertureObject::nApertureCount, FALSE);
		SetDlgItemInt(IDC_APER_ID, 
		((CApertureObject*) (pDoc->m_pApList)->GetAt(pos))->nIDThisAperture, FALSE); 
		SetDlgItemInt(IDC_TOTAL_LIST_COUNT, (pDoc->m_pApList)->GetCount(), FALSE);
	}
	
	if(!(pDoc->m_pApList)->IsEmpty())
	{
		pos = (pDoc->m_pApList)->GetHeadPosition();
		SetDlgItemInt(IDC_APER_ID, 
		((CApertureObject*) (pDoc->m_pApList)->GetAt(pos))->nIDThisAperture, FALSE);
	}
	else
		SetDlgItemInt(IDC_APER_ID, 0, FALSE); 

	return;
}
